"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var formater_1 = __importDefault(require("./formater"));
var Duration = /** @class */ (function () {
    function Duration(_duration, _unit) {
        if (_unit === void 0) { _unit = 'S'; }
        this._duration = _duration;
        this._unit = _unit;
        this._millisecond = Duration.convertToMillisecond(_duration, _unit);
    }
    Object.defineProperty(Duration.prototype, "millisecond", {
        get: function () {
            return this._millisecond;
        },
        enumerable: true,
        configurable: true
    });
    Duration.convertToMillisecond = function (value, type) {
        var millisecondValue = Duration.INPUT_TYPES.filter(function (v) { return v.type === type; })[0].millisecondValue;
        return value * millisecondValue;
    };
    Duration.prototype.format = function (token) {
        var formatter = new formater_1.default(this, token);
        return formatter.format();
    };
    Duration.FORMAT_TOKENS = /\*?[Hh]|\*?m+|\*?s+|./g;
    Duration.INPUT_TYPES = [
        {
            type: 'S',
            millisecondValue: 1
        },
        {
            type: 's',
            millisecondValue: 1000
        },
        {
            type: 'm',
            millisecondValue: 60000
        },
        {
            type: 'h',
            millisecondValue: 3600000
        }
    ];
    return Duration;
}());
exports.default = Duration;
